#!/usr/bin/env perl
#use strict;
#use warnings;
use File::Path;

die("Usage: ./control.pl UNIVSIZE TREESIZE NON-ISO-TREES source MAX.") if (@ARGV < 4);
my $UNIV = $ARGV[0];
my $NUM = $ARGV[1];
my $TREES = $ARGV[2];
my $SRC = $ARGV[3];
my $MAX = $ARGV[4];
my $TIME = time();
my $TEMP = "t$UNIV-$NUM-". $TIME;
mkdir "$TEMP";
mkdir "u$UNIV-$NUM";
print "Selecting candidates from $SRC into $TEMP/\n";
my $TOT = 0;
my $K = 0;
my $NUMP = $NUM+1;
my $I = 0;
my $GEN = `./tg $SRC $NUM $TEMP/ $MAX`;
print $GEN;
$MAX = 0 if $MAX eq "ALL";

while($I <= $MAX || $MAX == 0)
{    
     $I++;
     if($I % 10000 == 0)
     {
        print $I . "\n";
     }
     # print "processing graph $I\n";
     $TOT = 0;
     $K = `./tc $TEMP/$I.normal.txt $NUM`;
     $K += 0;
     # print $K . "\n";
     $TOT += $K;
     # print "Tot is now $TOT\n";
     $K = `./tc $TEMP/$I.subdiv.txt $NUMP`;
     $TOT += $K;
     # print "Tot is now $TOT\n";
     if ($TOT == $TREES)
     {
        print "Total fits.\n";
        `touch u$UNIV-$NUM/$TIME-$I`;
     } else {
        # print "Total does not fit, moving on.\n";
     }
     last if $GEN == $I;
}
rmtree($TEMP);

